#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<ll> sum(10);
    vector<int> bad(10);
    for (int i = 0; i < n; i++) {
        ll pw = 1;
        int a;
        cin >> a;
        while (a) {
            if (a < 10) bad[a] = 1;
            sum[a % 10] += pw;
            pw *= 10;
            a /= 10;
        }
    }

    ll best = -1;
    vector<int> p(10);
    iota(p.begin(), p.end(), 0);
    do {
        bool ok = true;
        ll res = 0;
        for (int i = 0; i < 10; i++) {
            if (p[i] == 0 && bad[i])
                ok = false;
            res += p[i] * sum[i];
        }
        if (ok)
            best = max(best, res);
    } while (next_permutation(p.begin(), p.end()));
    cout << best << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}