#include <bits/stdc++.h>


//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#define ull unsigned long long
#define pll pair<ll, ll>
#define mp make_pair
#define ll long long
#define ld long double
#define i128 ll
#define pb push_back
#define deb(x) cout << #x << " = " << x << endl
#define all(x) x.begin(), x.end()
#define vi vector<ll>
typedef std::complex<ld> cmpl;


const ll mod = 1e9 + 7;
const ll P = 179;
const ll inf = (ll)1e18;
const long double MATH_E = 2.718281828459;
const long double eps = 1e-9;
const long double MATH_PI = atan2l(0, -1);


using namespace std;


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<pll> modules(n);
    for (int i = 0; i < n; i++) {
        cin >> modules[i].first >> modules[i].second;
    }
    sort(all(modules));
    vector<pll> queries(q);
    vector<ll> suf_min(n);
    suf_min[n - 1] = modules[n - 1].second;
    for (int i = n - 2; i >= 0; i--) {
        suf_min[i] = min(suf_min[i + 1], modules[i].second);
    }
    for (int i = 0; i < q; i++) {
        cin >> queries[i].first;
        queries[i].second = i;
    }
    sort(all(queries));

    vector<ll> answer(q, -1);
    ll cnt_q = 0, s = 1, sm = 0, pos = 0;

    while (pos < n and modules[pos].first < s) {
        s += modules[pos].first;
        pos++;
    }

    while (cnt_q < q) {
        if (s >= queries[cnt_q].first) {
            answer[queries[cnt_q].second] = sm;
            cnt_q++;
        } else {
            if (pos == n) {
                break;
            }
            s += modules[pos].first;
            sm = suf_min[pos];
            pos++;
            while (pos < n and modules[pos].first <= s) {
                s += modules[pos].first;
                pos++;
            }
        }
    }
    for (auto x : answer) {
        cout << x << " ";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout.precision(30);
    srand(time(0));
    cout.setf(ios::fixed);
    solve();
    return 0;
}