#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), lim = opt<int>("lim");

    println(n);
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        a[i] = rnd.next(1, lim);
        b[i] = rnd.next(1, lim);
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());

    vector<pair<int, int>> res;
    res.push_back({a[0], b[0] + n});
    for (int i = 1; i < n; i++) {
        while (a[i] <= a[i - 1]) a[i]++;
        while (b[i] >= b[i - 1]) b[i]--;
        res.push_back({a[i], b[i] + n});
    }
    shuffle(res.begin(), res.end());
    for (auto &p : res) {
        println(p.first, p.second);
    }

}