#include "testlib.h"

using namespace std;

const int DEC9 = 1000'000'000;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int n = inf.readInt(2, 200'000, "n");
    vector<pair<int, int>> rect;
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        int a = inf.readInt(1, DEC9, format("a_%d", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, DEC9, format("b_%d", i + 1));
        inf.readEoln();
        rect.push_back({a, b});
    }
    sort(rect.begin(), rect.end());
    for (int i = 1; i < n; i++) {
        ensuref(rect[i].second < rect[i - 1].second, "rectangle (%d, %d) fits into (%d, %d)",
                rect[i - 1].first, rect[i - 1].second, rect[i].first, rect[i].second);
    }

    inf.readEof();

}