#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (int i = 0; i < v.size(); i++)
        in >> v[i];
    return in;
}

vector<ll> a;
ll B;
const ll p = 1000'000'007;

inline ll c1(ll x) {
    return x <= B;
}

inline ll c2(ll x, ll y) {
    return c1(x) && c1(y);
}

ll gen(int i, int px, int py) {
    if (i * 2 == a.size())
        return 1;

    ll cnt = 0;
    ll x = a[2 * i], y = a[2 * i + 1];
    cnt += (c1(px + x + y) + c1(py + x + y) + c2(px + x, py + y) + c2(px + y, py + x)) * gen(i + 1, 0, 0);
    cnt += (c1(px + x) + c1(py + x)) * 2 * gen(i + 1, 0, y);
    cnt += (c1(px + y) + c1(py + y)) * 2 * gen(i + 1, 0, x);
    cnt += 2 * gen(i + 1, x, y);
    if (c1(x + y)) cnt += 2 * gen(i + 1, 0, x + y);

    return cnt % p;
}

int main() {

    int n;
    cin >> n >> B;
    a.resize(2 * n);
    cin >> a;
    for (ll ai: a) {
        if (ai > B) {
            cout << 0 << '\n';
            return 0;
        }
    }

    ll cnt = 0;
    cnt += 2 * gen(1, a[0], a[1]);
    if (c1(a[0] + a[1]))
        cnt += 2 * gen(1, a[0] + a[1], 0);
    cout << cnt % p << '\n';

}