#include <bits/stdc++.h>
using namespace std;



int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> m;
    vector<int> t(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> t[i];
    }
    int n;
    cin >> n;
    vector<int> s(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1)),
            p(n + 1, vector<int>(m + 1, -1));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (j == 1) {
                dp[i][j] = 1;
            } else {
                for (int pred = i - 1; pred >= 0; pred--) {
                    if (s[i] - s[pred] == t[j] - t[j - 1]) {
                        if (dp[pred][j - 1]) {
                            dp[i][j] |= dp[pred][j - 1];
                            p[i][j] = pred;
                        }
                    }
                    if (s[pred] > s[i] - t[j]) {
                        break;
                    }
                }
            }
        }
    }
    int y = m, x = 1;
    for (; x <= n; x++) {
        if (dp[x][y]) {
            break;
        }
    }

    if (x <= n) {
        vector<int> path;

        while (y) {
            path.push_back(x);
            x = p[x][y];
            y--;
        }

        reverse(path.begin(), path.end());
        cout << "YES\n";
        for (auto i : path) {
            cout << i << ' ';
        }
    } else {
        cout << "NO";
    }

}