#include <bits/stdc++.h>
using namespace std;

const int LG = 17;
const int N = 100'010;
int st[LG][N], lg[N];


int dp[2][N], p[N], s[N], t[N];


void calc(int n) {
    for (int i = 2; i < N; i++) {
        lg[i] = lg[i / 2] + 1;
    }
    for (int i = 0; i < n; i++) {
        st[0][i] = s[i];
    }
    for (int i = 1; i < LG; i++)
        for (int j = 0; j + (1 << i) < N; j++)
            st[i][j] = max(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]);
}

int getMax(int l, int r) {
    if (l > r) {
        return -2e9;
    }
    return max(st[lg[r - l + 1]][l], st[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
}

int mp[(int)1e6];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    memset(p, -1, sizeof p);
    int m;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> t[i];
    }
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    calc(n);
    dp[0][0] = 1;

    for (int j = 1; j <= m; j++) {

        for (int i = 1; i <= n; i++) {
            if (j == 1) {
                dp[j % 2][i] = 1;
            } else {
                int ind = 0;
                if (s[i] - t[j] + t[j - 1] >= 0 && s[i] - t[j] + t[j - 1] < 1e6) {
                    ind = mp[s[i] - t[j] + t[j - 1]];
                }
                int mn = getMax(ind + 1, i - 1);
                if (mn <= s[i] - t[j]) {
                    dp[j % 2][i] |= dp[(j + 1) % 2][ind];
                    if (dp[j % 2][i]) {
                        p[i] = max(ind, p[i]);
                    }
                }
            }
            mp[s[i]] = i;
        }
        memset(dp[(j + 1) % 2], 0, sizeof dp[(j + 1) % 2]);
        memset(mp, 0, sizeof(mp));
    }
    int y = m, x = 1;
    for (; x <= n; x++) {
        if (dp[y % 2][x]) {
            break;
        }
    }

    if (x <= n) {
        vector<int> path;

        while (y) {
            path.push_back(x);
            x = p[x];
            y--;
        }

        reverse(path.begin(), path.end());
        cout << "YES\n";
        for (auto i : path) {
            cout << i << ' ';
        }
    } else {
        cout << "NO";
    }

}