#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &item: v)
        in >> item;
    return in;
}

int main() {

    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> b(a.begin(), a.end());
    for (int item: a) {
        b.push_back(item);
    }
    vector<int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = i;
    }
    auto build = [&](int i, vector<int> &out) {
        for (int t = a[i]; t < a[i] + n; t++) {
            int idx = t % n;
            if (idx != i) out.push_back(a[idx]);
        }
    };
    sort(res.begin(), res.end(), [&](int i, int j) {
        vector<int> s1, s2;
        build(i, s1), build(j, s2);
        for (int t = 0; t < n - 1; t++) {
            if (s1[t] != s2[t])
                return s1[t] < s2[t];
        }
        return false;
    });

    cout << res[0] + 1 << '\n';

}