using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const ll max_coordinate = 10'000'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, 10000, "n");
    inf.readSpace();
    int m = inf.readInt(1, 5000, "m");
    inf.readEoln();

    // ensuref(n * m <= 10'000'000, "n * m very big");

    unordered_map <ll, unordered_set<ll>> used_c;


    for (int i = 0; i < n + m; ++i) {
        ll x, y;
        x = inf.readLong(-max_coordinate, max_coordinate, "x_i");
        inf.readSpace();
        y = inf.readLong(-max_coordinate, max_coordinate, "y_i");
        inf.readEoln();

        if (used_c.find(x) != used_c.end() && used_c[x].find(y) != used_c[x].end()) {
            ensuref(false, "%d point is duplicate of other point", i);

        }
        if (used_c.find(x) == used_c.end()) {
            used_c[x] = unordered_set<ll>();
        }
        used_c[x].insert(y);
    }
    inf.readEof();

    return 0;
}
