using namespace std;

#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)
#define db(x) cout << x <<"\n";
#define db_(x) cout << x <<" ";

ll pifagor(const pair<int, int> &x, const pair<int, int> &y) {
    return sqr((ll) x.first - y.first) + sqr((ll) x.second - y.second);
}

void dfs(const vector<vector<int>> &g, int v, int from, vector<pair<int, int>> &path) {
    for (const auto &u : g[v]) {
        if (u != from) {
            path.emplace_back(v, u);
            dfs(g, u, v, path);
        }
    }
}

void solution() {
    int n, m;
    cin >> n >> m;

    vector <pair<int, int>> source(n);
    vector <pair<int, int>> user(m);
    fori(i, n) {
        cin >> source[i].first >> source[i].second;
    }

    fori(i, m) {
        cin >> user[i].first >> user[i].second;
    }

    int min_s = 0;
    ll min_s_len = LLONG_MAX;
    fori(i, m) {
        ll c_len = 0;
        fori(j, n) {
            c_len += pifagor(user[i], source[j]);
        }
        if (c_len < min_s_len) {
            min_s = i;
            min_s_len = c_len;
        }
    }

    ll ans = 0;

    vector<ll> min_u_e(m, LLONG_MAX);
    vector<bool> used_u(m);
    vector<int> se(m, -1);
    min_u_e[0] = 0;

    vector <vector<int>> ans_graph(m);
    vector <pair<int, int>> ans_edges;

    fori (i, m) {
        int v = -1;
        fori (u, m) {
            if (!used_u[u] && (v == -1 || min_u_e[u] < min_u_e[v])) {
                v = u;
            }
        }

        used_u[v] = true;
        if (se[v] != -1) {
            ans_graph[v].pb(se[v]);
            ans_graph[se[v]].pb(v);
            ans += pifagor(user[v], user[se[v]]);
        }

        fori(u, m) {
            ld q = pifagor(user[v], user[u]);
            if (q < min_u_e[u]) {
                min_u_e[u] = q;
                se[u] = v;
            }
        }
    }

    dfs(ans_graph, min_s, -1, ans_edges);


    cout.precision(11);

    cout << fixed << ans + min_s_len << endl;
    cout << n + m - 1 << endl;
    for (const auto &e : ans_edges) {
        cout << "u " << e.first + 1 << " -> " << e.second + 1 << endl;
    }
    fori(i, n) {
        cout << "s " << i + 1 << " -> " << min_s + 1 << endl;
    }
    //    cout << setprecision(11) << ans + min_s_len;
}

int main() {
//        freopen("test.in", "r", stdin);
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
    //    cout.tie(nullptr);

    solution();
}