def pifagor(x, y):
    return (x[0] - y[0]) ** 2 + (x[1] - y[1]) ** 2


n, m = [int(i) for i in input().split()]

sources = []
users = []

for j in range(n):
    x, y = [int(i) for i in input().split()]
    sources.append((x, y))

for j in range(m):
    x, y = [int(i) for i in input().split()]
    users.append((x, y))

min_ans = -1

s_to_u = []
for i in range(m):
    c = 0
    for j in range(n):
        c += pifagor(users[i], sources[j])
    s_to_u.append(c)

good_ans = -1
min_user = -1


def check(g):
    global good_ans, s_to_u, n, m, min_user, min_g
    used = []

    def dfs(v):
        d = 0
        used[v] = True
        for u in g[v]:
            if not used[u]:
                d += pifagor(users[u], users[v])
                d += dfs(u)
        return d

    for i in range(m):
        used = [False] * m
        dist = dfs(i)
        bad = False
        for v in used:
            if not v:
                bad = True
                break
        if not bad:
            r = dist + s_to_u[i]
            if good_ans == -1 or good_ans > r:
                good_ans = r
                min_user = i
                min_g = [list(e) for e in g]


def build_chains(x, y, g):
    global m
    if y == m:
        y = 0
        x += 1
    if x == m:
        check(g)
        return
    if x == y:
        build_chains(x, y + 1, g)
        return

    g[x].append(y)
    build_chains(x, y + 1, g)
    del g[x][-1]
    build_chains(x, y + 1, g)


g = [[] for i in range(m)]
build_chains(0, 0, g)
print(good_ans)
print(n + m - 1)
for i in range(n):
    print("s", i + 1, "->", min_user + 1)

used = [False] * m


def dfs_print(v, fr):
    global min_g, used
    if fr != -1:
        print("u", fr + 1, "->", v + 1)
    used[v] = True
    for u in min_g[v]:
        if not used[u]:
            dfs_print(u, v)


dfs_print(min_user, -1)
