#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <string>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <stdio.h>
#include <memory.h>
#include <cstdlib>
#include <time.h>
#include <bitset>
#include <random>
#include <chrono>

#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 1'000'000'007LL;
const int inf = 1e9;
const ll biginf = 2e18;
const ld pi = acosl(-1);
const ld eps = 1e-3;
const int maxn = 1e6 + 10;
const ll negativeInf = -1e18;

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int k = min(n, 40);
    vector<vector<ll> > pl(n, vector<ll>(k, 0)), pr(n, vector<ll>(k, 0));
    for (int i = 0; i < n; i++) {
        ll sl = 0, sr = 0;
        for (int j = 1; j < k; j++) {
            sr += a[(i + j) % n];
            sr /= 2;
            pr[(i + j) % n][j] = sr;
        }
        for (int j = 1; j < k; j++) {
            sl += a[(i - j + n) % n];
            sl /= 2;
            pl[(i - j + n) % n][j] = sl;
        }
    }
    vector<vector<ll> > opt(n, vector<ll>(k, 0));
    vector<ll> ans(k, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            for (int lsize = 0; lsize <= j; lsize++) {
                int rsize = j - lsize;
                if (j == n - 1 && rsize > 0) {
                    opt[i][j] = max(pr[(i - 1 + n) % n][lsize + 1] + pl[(i + 1) % n][rsize] + a[i], opt[i][j]);
                } else if (j == n - 1) {
                    opt[i][j] = max(pr[(i - 1 + n) % n][lsize] + pl[(i + 1) % n][rsize + 1] + a[i], opt[i][j]);
                } else {
                    opt[i][j] = max(pr[(i - 1 + n) % n][lsize] + pl[(i + 1) % n][rsize] + a[i], opt[i][j]);
                }
            }
            ans[j] = max(ans[j], opt[i][j]);
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        t = min(t, k - 1);
        cout << ans[t] << "\n";
    }
}

void multisolve() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; i++) {
        solve();
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}