using namespace std;

#include <iostream>
#include "testlib.h"

typedef long long ll;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    ll min_n = opt<ll>(1);
    ll max_n = opt<ll>(2);
    bool is_valid = opt<bool>(3);

    ll x = rnd.next(min_n, max_n);
    ll y = rnd.next(min_n, max_n);
    ll z = rnd.next(min_n, max_n);

    if (is_valid) {
        y = (y / 2) * 2 + x % 2;
        z = (z / 2) * 2 + x % 2;
    } else if (x % 2 == y % 2 && y % 2 == z % 2) {
        int choose = rnd.next(1, 3);
        if (choose == 1) {
            x += 1;
        } else if (choose == 2) {
            y += 1;
        } else {
            z += 1;
        }
    }

    if (x > max_n) {
        x -= 2;
    }
    if (y > max_n) {
        y -= 2;
    }
    if (z > max_n) {
        z -= 2;
    }

    std::cout << x << ' ' << y << ' ' << z << std::endl;
    return 0;
}

