#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;


long long f(long long m, long long lim, long long delta) {
    return min(lim, max(1LL, m + rnd.next(-delta, delta)));
}



int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    // 1 - n lim, 2 - q lim, 3 - m_i lim, 4 - c_i lim, 5 - x_i lim, 6 - eps

    int n = atoi(argv[1]);
    n = rnd.wnext(1, n, 3);
    int q = atoi(argv[2]);
    q = rnd.wnext(1, q, 3);
    int m_lim = atoi(argv[3]), c_lim = atoi(argv[4]), x_lim = atoi(argv[5]), eps = atoi(argv[6]);
    eps = rnd.next(1, eps);
    long long d = sqrt(c_lim);
    vector<pair<int, int>> modules(n);
    long long sum = 1;
    for (int i = 0; i < n; i++) {
        int doubled_val = rnd.next(sum + 1, sum + eps);
        if (doubled_val < m_lim) {
            modules[i].first = doubled_val;
        } else {
            modules[i].first = rnd.wnext(1, m_lim, 5);
            sum = m_lim;
        }
        modules[i].second = f(modules[i].first, c_lim, d);
        sum += modules[i].first;
    }
    shuffle(modules.begin(), modules.end());
    vector<int> x(q);
    for (int i = 0; i < q; i++) {
        x[i] = rnd.next(1, x_lim);
    }

    cout << n << " " << q << "\n";
    for (int i = 0; i < n; i++) {
        cout << modules[i].first << " " << modules[i].second << "\n";
    }
    for (int i = 0; i < q; i++) {
        cout << x[i];
        if (i + 1 < q) {
            cout << " ";
        }
    }
    cout << "\n";
}