#include <bits/stdc++.h>
 
#define ll long long
#define ull unsigned ll
#define vi vector<ll>
#define vvi vector<vi>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pii pair<ll, ll>
 
using namespace std;
 
const ll INF = (ll)2e9;
const ll inf = (ll)1e18;
const ld eps = (ld)1e-6;
const ll mod = (ll)1e9 + 7;
const ll MAXN = (ll)1e5;
const ll MAXLOG = 19;
const ll MAXC = (ll)1e7 + 1;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
 
template <class T>
istream& operator >>(istream &in, vector<T> &arr){
     for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};
 
void solve() {
    int n, q; cin >> n >> q;
    vector<pii> modules(n);
    for (int i = 0; i < n; ++i) {
        int m, c; cin >> m >> c;
        modules[i] = mp(m, c);
    }
    sort(all(modules));
    ll sum = 1;
    vi pref_sum(n + 1);
    vi sums = {0};
    vi min_suf(n + 1);
    pref_sum[0] = 1;
    for (int i = 0; i < n; ++i) {
        pref_sum[i + 1] = pref_sum[i] + modules[i].first;
    }
    min_suf[n] = modules[n - 1].second;
    for (int j = n - 1; j > 0; --j) {
        min_suf[j] = min(min_suf[j + 1], modules[j - 1].second);
    }
    for (int i = 0; i < n; ++i) {
        if (sum < modules[i].first) sums.push_back(i + 1);
        sum += modules[i].first;
    }
    while (q--) {
        int x; cin >> x;
        int pos = lower_bound(all(pref_sum), x) - pref_sum.begin();
        if (pos > n) {cout << -1 << "\n"; continue;}
        int i = upper_bound(all(sums), pos) - sums.begin() - 1;
        cout << min_suf[sums[i]] << " ";
    }
}
 
int main() {
    srand(time(0));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(50);
    solve();
 
    return 0;
}