//
// Created by Vlad on 06.11.2021.
//


#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int n;

void dfs(int v, vector<vector<int>> &sl, vector<bool> &used, int &c){
    c++;
    used[v] = true;
    for(int u: sl[v]){
        if(!used[u])dfs(u, sl, used, c);
    }
}

int test_answer(InStream &in){ //-1 for incorrect set, -2 for not tree, -3 for incorrect cnt, >=0 for correct
    int cnt = in.readInt(1, n, "trees_count");
    if(cnt != n / 2){
        return -3;
    }
    set<pair<int, int>> edges;
    for(int i = 0; i < cnt; i++){
        vector<vector<int>> sl(n);
        for(int j = 1; j < n; ++j){
            int u = in.readInt(1, n);
            int v = in.readInt(1, n);
            sl[--u].emplace_back(--v);
            sl[v].emplace_back(u);
            if(u > v)swap(u, v);
            if(edges.count({u, v}))return -1;
            edges.insert({u, v});
        }
        int c = 0;
        vector<bool> used(n);
        dfs(0, sl, used, c);
        if(c < n){
            return -2;
        }
    }
    return cnt;
}

int main(int argc, char *argv[]){
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    int participant = test_answer(ouf);
    if(participant == -1)quitf(_wa, "edges are dublicated");
    if(participant == -2)quitf(_wa, "some spans are not trees");
    if(participant == -3)quitf(_wa, "not enough trees");
    quitf(_ok, "");
}