#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), lim = opt<int>("lim"), raise = opt<int>("raise");

    println(n);

    vector<int> a(raise), b(raise);
    for (int i = 0; i < raise; i++) {
        a[i] = rnd.next(1, lim);
        b[i] = rnd.next(1, lim);
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());

    vector<pair<int, int>> res;
    res.push_back({a[0], b[0] + n});
    for (int i = 1; i < raise; i++) {
        while (a[i] <= a[i - 1]) a[i]++;
        while (b[i] >= b[i - 1]) b[i]--;
        res.push_back({a[i], b[i] + n});
    }

    for (int i = raise; i < n; i++) {
        int idx = rnd.next(-1, raise - 1);
        if (idx > -1) {
            if (rnd.next(2))
                res.push_back({rnd.next(res[idx].first / 2, res[idx].first),
                               rnd.next(max(1, res[idx].second - 20), res[idx].second)});
            else
                res.push_back({rnd.next(max(1, res[idx].first - 20), res[idx].first),
                               rnd.next(res[idx].second / 2, res[idx].second)});
        } else {
            res.push_back({rnd.next(1, lim), rnd.next(1, lim)});
        }
    }
    shuffle(res.begin(), res.end());

    for (int i = 0; i < n; i++) {
        println(res[i].first, res[i].second);
    }

}