// #include "testlib.h"
#include "jngen.h"
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void gen_rnd(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << rnd.next(1, maxc);
        if (i != n - 1) {
            cout << ' ';
        }
    }
    int m = rnd.next(n, maxm);
    cout << '\n' << m << '\n';
    for (int i = 0; i < m; i++) {
        cout << rnd.next(1, maxc);
        if (i != m - 1) {
            cout << ' ';
        }
    }
    cout << '\n';
}

void gen_ans(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    int m = rnd.next(n, maxm);
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, maxc);
        ind[i] = rnd.next(last, m - (n - i));
        last = ind[i] + 1;
    }

    int minn = *min_element(ans.begin(), ans.end());
    int maxx = *max_element(ans.begin(), ans.end());
    int x = rnd.next(-(minn - 1), maxc - maxx);
    int j = 0;

    for (int i = 0; i < m; i++) {
        if (j < n && ind[j] == i) {
            s[i] = ans[j] + x;
            j++;
        } else if (j == 0 || j == n) {
            s[i] = rnd.next(1, maxc);
        } else {
            s[i] = rnd.next(1, minn + x);
        }
    }

    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';
}


void gen_ans_1(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    int m = rnd.next(n, maxm);
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, maxc);
        ind[i] = rnd.next(last, m - (n - i));
        last = ind[i] + 1;
    }

    int minn = *min_element(ans.begin(), ans.end());
    int maxx = *max_element(ans.begin(), ans.end());
    int x = rnd.next(-(minn - 1), maxc - maxx);
    int j = 0;

    for (int i = 0; i < m; i++) {
        if (j < n && ind[j] == i) {
            s[i] = ans[j] + x;
            j++;
        } else if (j == 0 || j == n) {
            s[i] = rnd.next(1, maxc);
        } else {
            if (rnd.next(1)) {
                s[i] = rnd.next(1, minn + x);
            } else {
                s[i] = rnd.next(1, maxc);
            }
        }
    }



    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';
}

void gen_max(int maxn, int maxm, int maxc) {
    int n = maxn;
    int m = maxm;
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, maxc);
        ind[i] = rnd.next(last, m - (n - i));
        last = ind[i] + 1;
    }

    int minn = *min_element(ans.begin(), ans.end());
    int maxx = *max_element(ans.begin(), ans.end());
    int x = rnd.next(-(minn - 1), maxc - maxx);
    int j = 0;

    for (int i = 0; i < m; i++) {
        if (j < n && ind[j] == i) {
            s[i] = ans[j] + x;
            j++;
        } else if (j == 0 || j == n) {
            s[i] = rnd.next(1, maxc);
        } else {
            s[i] = rnd.next(1, minn + x);
        }
    }

    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';
}


void gen_max_1(int maxn, int maxm, int maxc) {
    int n = maxn;
    int m = maxm;
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, maxc);
        ind[i] = rnd.next(last, m - (n - i));
        last = ind[i] + 1;
    }

    int minn = *min_element(ans.begin(), ans.end());
    int maxx = *max_element(ans.begin(), ans.end());
    int x = rnd.next(-(minn - 1), maxc - maxx);
    int j = 0;

    for (int i = 0; i < m; i++) {
        if (j < n && ind[j] == i) {
            s[i] = ans[j] + x;
            j++;
        } else if (j == 0 || j == n) {
            s[i] = rnd.next(1, maxc);
        } else {
            if (rnd.next(1)) {
                s[i] = rnd.next(1, minn + x);
            } else {
                s[i] = rnd.next(1, maxc);
            }
        }
    }
    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';
}


void gen1(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    int m = maxm;
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, maxc);
        if (i != 0 && i != n - 1) {
            ind[i] = rnd.next(last, m - (n - i));
        }
        last = ind[i] + 1;
    }
    ind.back() = m;
    int minn = *min_element(ans.begin(), ans.end());
    int maxx = *max_element(ans.begin(), ans.end());
    int x = rnd.next(-(minn - 1), maxc - maxx);
    int j = 0;

    for (int i = 0; i < m; i++) {
        if (j < n && ind[j] == i) {
            s[i] = ans[j] + x;
            j++;
        } else if (j == 0 || j == n) {
            s[i] = rnd.next(1, maxc);
        } else {
            s[i] = rnd.next(1, minn + x);
        }
    }

    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';

}


void gen1_1(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    int m = maxm;
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, 5);
        if (i != 0 && i != n - 1) {
            ind[i] = rnd.next(last, m - (n - i));
        }
        last = ind[i] + 1;
    }
    sort(ans.rbegin(), ans.rend());
    s[0] = 1;
    for (int i = 1; i < m; i++) {
        s[i] = s[i - 1] + rnd.next(5, 10);
    }


    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';

}


void gen_no(int maxn, int maxm, int maxc) {
    int n = rnd.next(1, maxn);
    int m = maxm;
    vector<int> ans(n), s(m), ind(n);
    int last = 0;
    for (int i = 0; i < n; i++) {
        ans[i] = rnd.next(1, 5);
        if (i != 0 && i != n - 1) {
            ind[i] = rnd.next(last, m - (n - i));
        }
        last = ind[i] + 1;
    }
    sort(ans.begin(), ans.end());
    s[0] = maxc;
    for (int i = 1; i < m; i++) {
        s[i] = s[i - 1] - rnd.next(5, 10);
    }


    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i];
        if (i != n - 1) {
            cout << ' ';
        }
    }

    cout << endl << m << endl;
    for (int i = 0; i < m; i++) {
        cout << s[i];
        if (i != m - 1) {
            cout << ' ';
        }
    }

    cout << '\n';

}


int main(int argc, char** argv) {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    registerGen(argc, argv, 1);
    int maxn = atoi(argv[1]);
    int maxm = atoi(argv[2]);
    int maxc = atoi(argv[3]);
    int t = atoi(argv[4]);

    if (t == 1) {
        gen_rnd(maxn, maxm, maxc);
    } else if (t == 2) {
        gen_ans(maxn, maxm, maxc);
    } else if (t == 3) {
        gen_ans_1(maxn, maxm, maxc);
    } else if (t == 4) {
        gen_max(maxn, maxm, maxc);
    } else if (t == 5) {
        gen_max_1(maxn, maxm, maxc);
    } else if (t == 6) {
        gen1(maxn, maxm, maxc);
    } else if (t == 7) {
        gen1_1(maxn, maxm, maxc);
    } else if (t == 8) {
        gen_no(maxn, maxm, maxc);
    }


    return 0;
}