#include <bits/stdc++.h>
using namespace std;

const int LG = 20;
const int N = 100'010;
int st[LG][N], lg[N];

void calc(vector<int>& a) {
    for (int i = 2; i < N; i++) {
        lg[i] = lg[i / 2] + 1;
    }
    for (int i = 0; i < a.size(); i++) {
        st[0][i] = a[i];
    }
    for (int i = 1; i <= LG; i++)
        for (int j = 0; j + (1 << i) <= N; j++)
            st[i][j] = max(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]);
}

int getMax(int l, int r) {
    if (l > r) {
        return -2e9;
    }
    return max(st[lg[r - l + 1]][l], st[lg[r - l + 1]][r - (1 << lg[r - l + 1]) + 1]);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> m;
    vector<int> t(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> t[i];
    }
    int n;
    cin >> n;
    vector<int> s(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1)),
            p(n + 1, vector<int>(m + 1, -1));
    calc(s);
    unordered_map<int, int> mp;
    dp[0][0] = 1;
    for (int j = 1; j <= m; j++) {
        mp.clear();
        for (int i = 1; i <= n; i++) {
            if (j == 1) {
                dp[i][j] = 1;
            } else {
                int mn = getMax(mp[s[i] - t[j] + t[j - 1]] + 1, i - 1);
                if (mn <= s[i] - t[j]) {
                    dp[i][j] |= dp[mp[s[i] - t[j] + t[j - 1]]][j - 1];
                    if (dp[i][j]) {
                        p[i][j] = mp[s[i] - t[j] + t[j - 1]];
                    }
                }
            }
            mp[s[i]] = i;
        }
    }
    int y = m, x = 1;
    for (; x <= n; x++) {
        if (dp[x][y]) {
            break;
        }
    }

    if (x <= n) {
        vector<int> path;

        while (y) {
            path.push_back(x);
            x = p[x][y];
            y--;
        }

        reverse(path.begin(), path.end());
        cout << "YES\n";
        for (auto i : path) {
            cout << i << ' ';
        }
    } else {
        cout << "NO";
    }

}