#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), lim = opt<int>("lim"), skew = opt<int>("skew");

    vector<int> remap(n);
    for (int i = 0; i < n; i++) {
        remap[i] = i;
    }
    shuffle(remap.begin(), remap.end());

    println(n);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = rnd.next(1, lim);
        for (int t = 0; t < skew; t++)
            a[i] = min(a[i], rnd.next(1, lim));
        a[i] = remap[--a[i]];
    }
    println(a.begin(), a.end());

}