// #include "testlib.h"
#include "jngen.h"
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void gen_rnd(int maxn, int maxm, int maxc) {
    int n = rnd.next(3, maxn);
    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << rnd.next(1, maxc);
        if (i != n - 1) {
            cout << ' ';
        }
    }
    int m = rnd.next(1, maxm);
    cout << '\n' << m << '\n';
    for (int i = 0; i < m; i++) {
        cout << rnd.next(1, n);
        if (i != m - 1) {
            cout << ' ';
        }
    }
    cout << '\n';
}


void gen_max(int maxn, int maxm,  int maxc) {
    int n = maxn;
    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << rnd.next(1, maxc);
        if (i != n - 1) {
            cout << ' ';
        }
    }
    int m = maxm;
    cout << '\n' << m << '\n';
    for (int i = 0; i < min(31, m); i++) {
        cout << min(i + 1, n);
        if (i != m - 1) {
            cout << ' ';
        }
    }
    for (int i = 31; i < m; i++) {
        cout << rnd.next(1, n);
        if (i != m - 1) {
            cout << ' ';
        }
    }
    cout << '\n';
}


int main(int argc, char** argv) {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    registerGen(argc, argv, 1);
    int maxn = atoi(argv[1]);
    int maxm = atoi(argv[2]);
    int maxc = atoi(argv[3]);
    int t = atoi(argv[4]);

    if (t == 1) {
        gen_rnd(maxn, maxm, maxc);
    } else if (t == 2) {
        gen_max(maxn, maxm, maxc);
    }


    return 0;
}