#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MOD = 1e9 + 7;
const int M = 60;

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> best(M * 2, -1);
    for (int i = 0; i < n; i++) {
        vector<ll> x(M), y(M);
        for (int j = 0; j < min(n, M); j++) {
            for (int k = i - j; k < i; k++) {
                x[j] = x[j] / 2 + a[(k + n) % n];
            }
            for (int k = i + j; k > i; k--) {
                y[j] = y[j] / 2 + a[k % n];
            }
        }
        for (int l = 0; l < min(n, M); l++) {
            for (int r = 0; r < min(n, M) && 1 + l + r <= n; r++) {
                if (1 + l + r < n) {
                    best[l + r] = max(best[l + r], x[l] / 2 + a[i] + y[r] / 2);
                } else {
                    auto mem = a;
                    for (int k = i - l; k < i; k++) {
                        mem[(k - 1 + n) % n] += mem[(k + n) % n] / 2;
                        mem[(k + 1 + n) % n] += mem[(k + n) % n] / 2;
                    }
                    for (int k = i + r; k > i; k--) {
                        mem[(k - 1 + n) % n] += mem[(k + n) % n] / 2;
                        mem[(k + 1 + n) % n] += mem[(k + n) % n] / 2;
                    }
                    best[l + r] = max(best[l + r], mem[i]);

                    mem = a;
                    for (int k = i + r; k > i; k--) {
                        mem[(k - 1 + n) % n] += mem[(k + n) % n] / 2;
                        mem[(k + 1 + n) % n] += mem[(k + n) % n] / 2;
                    }
                    for (int k = i - l; k < i; k++) {
                        mem[(k - 1 + n) % n] += mem[(k + n) % n] / 2;
                        mem[(k + 1 + n) % n] += mem[(k + n) % n] / 2;
                    }
                    best[l + r] = max(best[l + r], mem[i]);
                }
            }
        }
    }
    for (int i = 1; i < best.size(); i++) {
        best[i] = max(best[i], best[i - 1]);
    }
    int q;
    cin >> q;
    while (q--) {
        int a;
        cin >> a;
        cout << best[min(a, M * 2 - 1)] << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case #" << tc << ": ";
        solve();
    }
    return 0;
}